<template>
  <div class="questionPage animate__animated animate__zoomIn">
    <QuestionLoadingScreen v-if="!questionsLoaded" />
    <QuestionErrorScreen
      v-if="questionErrorMessage.length > 0"
      :errorMessage="questionErrorMessage"
    />
    <QuestionPageQuestion v-if="questions.length > 0" />
    <QuestionPageAlternatives v-if="questions.length > 0" />
  </div>
</template>

<script>
import QuestionLoadingScreen from "../components/QuestionPage/QuestionLoadingScreen.vue";
import QuestionErrorScreen from "../components/QuestionPage/QuestionErrorScreen.vue";
import QuestionPageQuestion from "../components/QuestionPage/QuestionPageQuestion.vue";
import QuestionPageAlternatives from "../components/QuestionPage/QuestionPageAlternatives/QuestionPageAlternatives.vue";
import { mapActions, mapState } from "vuex";

export default {
  name: "QuestionPage",
  data() {
    return {
      questionErrorMessage: "",
    };
  },

  components: {
    QuestionLoadingScreen,
    QuestionErrorScreen,
    QuestionPageQuestion,
    QuestionPageAlternatives,
  },

  async created() {
    try {
      await this.fetchQuestions();
    } catch (error) {
      this.questionError = true;
      this.questionErrorMessage = error.message;
    }
  },

  computed: {
    ...mapState([
      "questionIndex",
      "numberOfQuestions",
      "questionsLoaded",
      "questions",
    ]),
  },

  methods: {
    ...mapActions(["fetchQuestions"]),
  },

  watch: {
    /**
     * Tracks if all the questions have been answered. When that happens, it routes the user to the results page.
     */
    questionIndex: function () {
      if (this.questionIndex >= this.numberOfQuestions) {
        this.$router.push("/result");
      }
    },
  },
};
</script>

<style>
.questionPage {
  background-color: rgb(192, 235, 250);
  border: 1px solid grey;
  border-radius: 20%;
  padding: 50px;
}
</style>